theory Transform_DP_Setup
  imports
    "../DP_CRelVS" "../DP_CRelVS_Ext" "../scratch/Memory"
  keywords
    "transform_dp_def" :: thy_decl
    and "transform_dp_def_eqs" :: thy_decl
    and "transform_dp_crel" :: thy_goal
begin

ML_file \<open>Transform_Misc.ML\<close>
ML_file \<open>Transform_Const.ML\<close>
ML_file \<open>Transform_Term.ML\<close>
ML_file \<open>Transform_Tactic.ML\<close>
ML_file \<open>Transform2.ML\<close>

method_setup dp_match = \<open>
Scan.succeed (fn ctxt => (SIMPLE_METHOD' (Transform_Tactic.solve_crel_tac ctxt)))
\<close>

method_setup dp_match_init = \<open>
Scan.succeed (fn ctxt => (SIMPLE_METHOD' (Transform_Tactic.prepare_lemma_tac ctxt)))
\<close>

method_setup dp_match_step = \<open>
Scan.succeed (fn ctxt => (SIMPLE_METHOD' (Transform_Tactic.step_tac ctxt)))
\<close>

ML \<open>
val _ =
  Outer_Syntax.local_theory @{command_keyword transform_dp_def}
    "transform dp definition"
    (Scan.option Parse.term >> Transform_DP.lift_fun_cmd)

val _ = 
  Outer_Syntax.local_theory @{command_keyword transform_dp_def_eqs}
    "transform dp definition"
    (Scan.option Parse.term >> (fn tm_opt => Transform_DP.lift_function_defs Syntax.read_term true tm_opt #> snd))



val _ =
  Outer_Syntax.local_theory_to_proof @{command_keyword transform_dp_crel}
    "prove consistentDP"
    (Scan.option Parse.term >> Transform_DP.gen_crel_cmd)
\<close>

end